/*
 * This file is part of Skyward Hub.
 *
 * Skyward Hub is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * Skyward Hub is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Skyward Hub. If not, see <https://www.gnu.org/licenses/>.
 *
 */

#pragma once

#include <Modules/Module.h>

#include <QListWidget>
#include <QStackedWidget>
#include <QWidget>

class TabsModule : public Module
{
    Q_OBJECT

public:
    TabsModule();

    void addTab(const QString& tabName, Module* module);

    XmlObject toXmlObject() override;
    void fromXmlObject(const XmlObject& xmlObject) override;

private slots:
    void replaceTab(Module* oldModule, Module* newModule);
    void closeTab(Module* module);
    void onDoubleClickedItem(QListWidgetItem* item);

    void onMenuNewTabClick();
    void onMenuDeleteTabClick();
    void onMenuRenameTabClick();

private:
    void setupUi();
    void customContextMenuActionSetup();

    QString generateUniqueTabName();

    QListWidget* tabNames;
    QStackedWidget* tabContents;
    QList<Module*> contentModules;
};
